/* 
dial.c 
ALICE V 2.0, January 1993
library functions for dialogue programming 
(C) Ralf Kaufmann 1993 
used C compiler: Pure C 
*/ 
 
/* functions contained in this module: 
handle_dial 
*/ 
 
/* Includefiles */ 
 
# include <ctype.h> 
# include <math.h> 
# include <stdio.h> 
# include <stdlib.h> 
# include <string.h> 
 
# include <aes.h> 
# include <tos.h> 
# include <vdi.h> 

# include "language.h" 
# include "prvdef.h" 
# include "mewidi.h" 
# include "messages.h" 
# include "scancode.h" 
# include "structs.h" 
# include "extdef.h" 
# include "rsc.h" 
 
/* References to global data defined elsewhere  */ 
 
extern  int   clocky;

 
/**********************/ 
/* Start of routines  */ 
/**********************/ 
 
 
 
 
/* main routine for handling dialogue boxes */ 
 
int     handle_dial (dial_tree, start_obj) 
OBJECT  *dial_tree; 
int     start_obj; 
{                                     /* start function handle_dial */ 
  int           itemhit, x, y, w, h; 
  unsigned int  ob_state; 
 
  MOUSE_IS_ARROW;
  form_center (dial_tree, &x, &y, &w, &h); 
  form_dial   (FMD_START, 0, 0, 0, 0, x, y, w, h); 
  objc_draw   (dial_tree, ROOT, MAX_DEPTH, x, y, w, h); 
 
  itemhit   = form_do (dial_tree, start_obj); 
 
  ob_state  = dial_tree[itemhit].ob_state & ~SELECTED; 
  objc_change (dial_tree, itemhit, 0, x, y, w, h, ob_state, 0); 
  form_dial   (FMD_FINISH, 0, 0, 0, 0, x, y, w, h); 
  display_time (clocky); 
  return (itemhit); 
}                                       /* end function handle_dial */ 
 
/* end of file dial.c  */ 
 
