/* 
extdef.h 
ALICE V 2.0, January 1993 
header for external definitions 
(C) Ralf Kaufmann 1993
used C compiler: Pure C 
*/ 
 
 
/*  Declare VDI globals */ 
 
extern int  contrl[12]; 
extern int  intin[256],  ptsin[256]; 
extern int  intout[256], ptsout[256]; 
extern int  work_in[12], work_out[57]; 
 
 
 
/* function prototypes  */ 
 
void        add_element (LINE_DESC  *p, 
                         int        w_index); 
 
void        add_element_buffer (LINE_DESC *e, 
                                int       b_index); 
                                
void        add_element_include_buffer (LINE_DESC *e); 
 
int         align (int k, 
                   int n); 
                   
int         alternate_key (void);

int         block_set (int w_index); 
 
void        buf_enable (int flag); 
 
void        cap_check (int w_index); 
 
void        cap_enable (int flag); 

int         cfg_read (void);
 
int         cfg_write (void);
 
void        clear_block_flags (int w_index); 

void        clear_window (int w_handle); 
 
void        clip_window (int w_handle, 
                         int flag); 
 
int         control_key (void);

int         copy_block (int w_index); 
 
int         create_file (char	*filename, int  w_index); 
 
LINE_DESC   *create_list_element (void); 
 
int         cursor (int w_handle, 
                    int mode); 
 
int         cursor_visible (int w_index); 
 
void        delete_block (int w_index); 
 
int         delete_file (void); 

int         do_replace  (void);

void				doc_info (void);

void        disable_menu (void);
 
void        display_time (int flag); 
 
void        display_pos (int w_index);

int         do_redraw (int w_handle, 
                       int x, 
                       int y, 
                       int w, 
                       int h, 
                       int clear); 
 
int         easy_open_window (char  *w_name, 
                              void  (*redraw)(), 
                              int   w_index); 
 
int         exist_buffer (void); 
 
int         exist_wind (void); 
 
void        file_not_saved (void); 
 
void  			find_next_word (int   w_index, 
            			          long  *next_curs_x, 
                  			    long  *next_curs_y);

size_t      first_match (char *p, char *q, int respect_case); 
 
int         full_redraw (int w_handle, int clear); 
 
int         gemdos_major (void); 
 
int         gemdos_minor (void); 
 
void        gem_exit (int rsrc); 
 
int         gem_init (void); 
 
long        get_byte_size (int w_index); 
 
int         get_free_index (void); 
 
int         get_index_from_handle (int w_handle); 
 
long        get_max_line_length (int w_index); 
 
void        goto_line (int w_index, long line); 
 
int         handle_dial (OBJECT *dial_tree, 
                         int    start_obj); 
 
int         handle_full (int w_handle); 
 
int         handle_keybd (int key); 
 
int         handle_menu (int title, 
                         int item); 
 
int         handle_mouse (int x, 
                          int y, 
                          int button); 
 
void				handle_options (void);

int					handle_print (void);

int         handle_shortcut (int key); 

int         handle_window (int buffer[MSG_BUFFER]); 
 
int         init_buffer (int b_index); 
 
int         init_include_buffer (void); 
 
size_t      last_match (char  *p, 
                        int   n, 
                        char  *q,
                        int   respect_case); 
 
LINE_DESC   *line_ptr (int    w_index, 
                       size_t number); 
 
int         line_length (int  w_index, 
                         long number); 
 
long        max (long a, long b); 
 
long        min (long a, long b); 
 
int         more_windows (void);

void				udf (void);

int         number_of_pages (int w_index);

int         old_gemdos (void); 
 
int         open_window (char   *w_name, 
                         void   (*redraw)(), 
                         int    was, 
                         int    algn_x, 
                         int    algn_y, 
                         int    algn_w, 
                         int    algn_h, 
                         int    snp, 
                         int    w_index, 
                         long   doc_w, 
                         long   doc_l); 
 
void        output (int   w_handle, 
                    GRECT *area, 
                    int   clear); 
 
int         own_top_wind (void); 
 
int         paste_block (int w_index); 

int         paste_include_file (int w_index); 
 
int         print_file (int w_index); 

int         print_line (char  line[], int print_device);
 
void        put_graphic_char (char    c, 
                              size_t  x, 
                              size_t  y,
                              int     w_index); 
 
void        put_message (int msg_nr);

void        rcopy (int xs, 
                   int ys, 
                   int ws, 
                   int hs, 
                   int xd, 
                   int yd, 
                   int mode); 
 
int         read_file (char	*filename, int  w_index); 
 
int         read_file_buffer (char  *filename, 
                              int   b_index); 
 
int         read_include_file (char *filename); 
 
int         rect_equal (GRECT *r1, 
                        GRECT *r2); 
 
int         rect_intersect (GRECT *r1, 
                            GRECT *r2, 
                            GRECT *r3); 
 
void        repl_message (long count); 

void        refresh_window (int w_handle);

void        restore_buffer_names (void);

void        rk_strexp (char *p, 
                       int  b); 
 
int         rk_strrchr (char str[], 
                        char c); 
 
void        set_slider_pos (int w_handle); 
 
void        set_slider_size (int w_handle); 
 
void        save_buffer_names (void);

void        say (char *string); 
 
int         scroll_wind (int w_handle, 
                         int what); 
 
int         search (int   w_index, 
                    long  search_start_x, 
                    long  search_start_y, 
                    int   search_direction, 
                    char  *search_string,
                    int   search_case, 
                    long  *found_x, 
                    long  *found_y); 
 
void				select_buffer (void);

void        set_slider_pos (int w_handle); 
 
void        set_slider_size (int w_handle); 
 
void        snap (GRECT *r1, 
                  GRECT *r2); 
 
int         top_wind (void); 

void        wd_calc_work (int w_handle, 
                          int x, 
                          int y, 
                          int w, 
                          int h); 
 
int         wind_hslide (int w_handle, 
                         int newpos); 
 
int         wind_vslide (int w_handle, 
                         int newpos); 
 
int         write_file (char	*filename, int   w_index); 
 
 
 
 
/* end of file extdef.h */ 
